# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class BasicAccountDetails(pydantic.BaseModel):
    name: str = pydantic.Field(
        description=(
            "The account name, according to the institution.  Note that some institutions allow\n"
            "        the end user to nickname the account; in such cases this field may be the name assigned by the user\n"
        )
    )
    last_synced_at: typing.Optional[str] = pydantic.Field(
        description=("An ISO-8601 timestamp indicating the last time that the account was updated.\n")
    )
    institution_id: str
    link_id: str = pydantic.Field(description=("The unique ID of the link this account belongs to.\n"))

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
