# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class LinkPermissionScope(str, enum.Enum):
    """
    Permissions that a link has access to. These are accepted by a user.
    """

    ACCOUNTS = "accounts"
    ACCOUNT_NUMBERS = "account_numbers"
    IDENTITY = "identity"
    TRANSACTIONS = "transactions"

    def visit(
        self,
        accounts: typing.Callable[[], T_Result],
        account_numbers: typing.Callable[[], T_Result],
        identity: typing.Callable[[], T_Result],
        transactions: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is LinkPermissionScope.ACCOUNTS:
            return accounts()
        if self is LinkPermissionScope.ACCOUNT_NUMBERS:
            return account_numbers()
        if self is LinkPermissionScope.IDENTITY:
            return identity()
        if self is LinkPermissionScope.TRANSACTIONS:
            return transactions()
