# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .transaction import Transaction


class TransactionDiff(pydantic.BaseModel):
    created: typing.List[Transaction] = pydantic.Field(
        description=("A list of transactions that have been added to the link ordered by ascending datetime.\n")
    )
    updated: typing.List[Transaction] = pydantic.Field(
        description=("A list of transactions that have been updated on the link ordered by ascending datetime.\n")
    )
    removed: typing.List[str] = pydantic.Field(
        description=("A list of transaction ids that have been removed from the link ordered by ascending datetime.\n")
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
