# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .transactions_product_settings import TransactionsProductSettings


class TransactionsLinkProduct(pydantic.BaseModel):
    refreshed_at: typing.Optional[str] = pydantic.Field(
        description=("An ISO-8601 timestamp indicating the last time that the product was updated.\n")
    )
    last_attempted_at: typing.Optional[str] = pydantic.Field(
        description=("An ISO-8601 timestamp indicating the last time that the product was attempted.\n")
    )
    settings: TransactionsProductSettings

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
